diff --git a/yumcommands.py b/yumcommands.py
index 4dcbea7..b610f3a 100644
--- a/yumcommands.py
+++ b/yumcommands.py
@@ -514,140 +1058,573 @@ class GroupsCommand(YumCommand):
         if cmd == 'list':
             return base.returnGroupLists(extcmds)
 
-        try:
+        if True: # Try, YumBase...
             if cmd == 'info':
                 return base.returnGroupInfo(extcmds)
             if cmd == 'install':
                 return base.installGroups(extcmds)
             if cmd == 'upgrade':
-                return base.installGroups(extcmds, upgrade=True)
+                ret = base.installGroups(extcmds, upgrade=True)
+                updateinfo.remove_txmbrs(base)
+                return ret
             if cmd == 'remove':
                 return base.removeGroups(extcmds)
 
-        except yum.Errors.YumBaseError, e:
-            return 1, [str(e)]
+            if cmd == 'mark-install':
+                gRG = base._groupReturnGroups(extcmds,ignore_case=False)
+                igrps, grps, ievgrps, evgrps = gRG
+                for evgrp in evgrps:
+                    base.igroups.add_environment(evgrp.environmentid,
+                                                 evgrp.allgroups)
+                for grp in grps:
+                    pkg_names = set() # Only see names that are installed.
+                    for pkg in base.rpmdb.searchNames(grp.packages):
+                        pkg_names.add(pkg.name)
+                    base.igroups.add_group(grp.groupid, pkg_names)
+                base.igroups.save()
+                return 0, ['Marked install: ' + ','.join(extcmds)]
+
+            if cmd == 'mark-blacklist':
+                gRG = base._groupReturnGroups(extcmds,ignore_case=False)
+                igrps, grps, ievgrps, evgrps = gRG
+                for ievgrp in ievgrps:
+                    evgrp = base.comps.return_environment(igrp.evgid)
+                    if not evgrp:
+                        continue
+                    base.igroups.changed = True
+                    ievgrp.grp_names.update(grp.groups)
+                for igrp in igrps:
+                    grp = base.comps.return_group(igrp.gid)
+                    if not grp:
+                        continue
+                    base.igroups.changed = True
+                    igrp.pkg_names.update(grp.packages)
+                base.igroups.save()
+                return 0, ['Marked upgrade blacklist: ' + ','.join(extcmds)]
+
+            if cmd in ('mark-packages', 'mark-packages-force'):
+                if len(extcmds) < 2:
+                    return 1, ['No group or package given']
+                gRG = base._groupReturnGroups([extcmds[0]],
+                                              ignore_case=False)
+                igrps, grps, ievgrps, evgrps = gRG
+                if igrps is None or len(igrps) != 1:
+                    return 1, ['No group matched']
+                grp = igrps[0]
+                force = cmd == 'mark-packages-force'
+                for pkg in base.rpmdb.returnPackages(patterns=extcmds[1:]):
+                    if not force and 'group_member' in pkg.yumdb_info:
+                        continue
+                    pkg.yumdb_info.group_member = grp.gid
+                    grp.pkg_names.add(pkg.name)
+                    base.igroups.changed = True
+                base.igroups.save()
+                return 0, ['Marked packages: ' + ','.join(extcmds[1:])]
+
+            if cmd == 'unmark-packages':
+                for pkg in base.rpmdb.returnPackages(patterns=extcmds):
+                    if 'group_member' in pkg.yumdb_info:
+                        del pkg.yumdb_info.group_member
+                return 0, ['UnMarked packages: ' + ','.join(extcmds)]
+
+            if cmd in ('mark-packages-sync', 'mark-packages-sync-force'):
+                gRG = base._groupReturnGroups(extcmds,ignore_case=False)
+                igrps, grps, ievgrps, evgrps = gRG
+                if not igrps:
+                    return 1, ['No group matched']
+                force = cmd == 'mark-packages-sync-force'
+                for grp in igrps:
+                    for pkg in base.rpmdb.searchNames(grp.pkg_names):
+                        if not force and 'group_member' in pkg.yumdb_info:
+                            continue
+                        pkg.yumdb_info.group_member = grp.gid
+                if force:
+                    return 0, ['Marked packages-sync-force: '+','.join(extcmds)]
+                else:
+                    return 0, ['Marked packages-sync: ' + ','.join(extcmds)]
+
+            if cmd in ('mark-groups', 'mark-groups-force'):
+                if len(extcmds) < 2:
+                    return 1, ['No environment or group given']
+                gRG = base._groupReturnGroups([extcmds[0]],
+                                              ignore_case=False)
+                igrps, grps, ievgrps, evgrps = gRG
+                if ievgrps is None or len(ievgrps) != 1:
+                    return 1, ['No environment matched']
+                evgrp = ievgrps[0]
+                force = cmd == 'mark-groups-force'
+                gRG = base._groupReturnGroups(extcmds[1:], ignore_case=False)
+                for grp in gRG[1]:
+                    # Packages full or empty?
+                    self.igroups.add_group(grp.groupid,
+                                           grp.packages, ievgrp)
+                if force:
+                    for grp in gRG[0]:
+                        grp.environment = evgrp.evgid
+                        base.igroups.changed = True
+                base.igroups.save()
+                return 0, ['Marked groups: ' + ','.join(extcmds[1:])]
+
+            if cmd == 'unmark-groups':
+                gRG = base._groupReturnGroups([extcmds[0]],
+                                              ignore_case=False)
+                igrps, grps, ievgrps, evgrps = gRG
+                if igrps is None:
+                    return 1, ['No groups matched']
+                for grp in igrps:
+                    grp.environment = None
+                    base.igroups.changed = True
+                base.igroups.save()
+                return 0, ['UnMarked groups: ' + ','.join(extcmds)]
+
+            if cmd in ('mark-groups-sync', 'mark-groups-sync-force'):
+                gRG = base._groupReturnGroups(extcmds,ignore_case=False)
+                igrps, grps, ievgrps, evgrps = gRG
+                if not ievgrps:
+                    return 1, ['No environment matched']
+                force = cmd == 'mark-groups-sync-force'
+                for evgrp in ievgrps:
+                    grp_names = ",".join(sorted(evgrp.grp_names))
+                    for grp in base.igroups.return_groups(grp_names):
+                        if not force and grp.environment is not None:
+                            continue
+                        grp.environment = evgrp.evgid
+                        base.igroups.changed = True
+                base.igroups.save()
+                if force:
+                    return 0, ['Marked groups-sync-force: '+','.join(extcmds)]
+                else:
+                    return 0, ['Marked groups-sync: ' + ','.join(extcmds)]
+
+            # FIXME: This doesn't do environment groups atm.
+            if cmd in ('mark-convert',
+                       'mark-convert-whitelist', 'mark-convert-blacklist'):
+                # Convert old style info. into groups as objects.
+
+                def _convert_grp(grp):
+                    if not grp.installed:
+                        return
+                    pkg_names = []
+                    for pkg in base.rpmdb.searchNames(grp.packages):
+                        if 'group_member' in pkg.yumdb_info:
+                            continue
+                        pkg.yumdb_info.group_member = grp.groupid
+                        pkg_names.append(pkg.name)
+
+                    #  We only mark the packages installed as a known part of
+                    # the group. This way "group update" will work and install
+                    # any remaining packages, as it would before the conversion.
+                    if cmd == 'mark-convert-whitelist':
+                        base.igroups.add_group(grp.groupid, pkg_names)
+                    else:
+                        base.igroups.add_group(grp.groupid, grp.packages)
+
+                # Blank everything.
+                for gid in base.igroups.groups.keys():
+                    base.igroups.del_group(gid)
+                for pkg in base.rpmdb:
+                    if 'group_member' in pkg.yumdb_info:
+                        del pkg.yumdb_info.group_member
+
+                #  Need to do this by hand, when using objects, to setup the
+                # .installed attribute in comps.
+                base.comps.compile(base.rpmdb.simplePkgList())
+
+                #  This is kind of a hack, to work around the biggest problem
+                # with having pkgs in more than one group. Treat Fedora/EL/etc.
+                # base/core special. Maybe other groups?
+
+                #  Not 100% we want to force install "core", as that's then
+                # "different", but it is better ... so, meh.
+                special_gids = (('core', True),
+                                ('base', False))
+                for gid, force_installed in special_gids:
+                    grp = base.comps.return_group(gid)
+                    if grp is None:
+                        continue
+                    if force_installed:
+                        grp.installed = True
+                    _convert_grp(grp)
+                for grp in base.comps.get_groups():
+                    if grp.groupid in special_gids:
+                        continue
+                    _convert_grp(grp)
+                    
+                base.igroups.save()
+                return 0, ['Converted old style groups to objects.']
+
+            if cmd == 'mark-remove':
+                gRG = base._groupReturnGroups(extcmds,ignore_case=False)
+                igrps, grps, ievgrps, evgrps = gRG
+                for evgrp in ievgrps:
+                    base.igroups.del_environment(evgrp.evgid)
+                for grp in igrps:
+                    base.igroups.del_group(grp.gid)
+                base.igroups.save()
+                return 0, ['Marked remove: ' + ','.join(extcmds)]
 
 
     def needTs(self, base, basecmd, extcmds):
+        """Return whether a transaction set must be set up before this
+        command can run.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: True if a transaction set is needed, False otherwise
+        """
         cmd, extcmds = self._grp_cmd(basecmd, extcmds)
 
         if cmd in ('list', 'info', 'remove', 'summary'):
             return False
+        if cmd.startswith('mark') or cmd.startswith('unmark'):
+            return False
         return True
 
     def needTsRemove(self, base, basecmd, extcmds):
+        """Return whether a transaction set for removal only must be
+        set up before this command can run.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: True if a remove-only transaction set is needed, False otherwise
+        """
         cmd, extcmds = self._grp_cmd(basecmd, extcmds)
 
         if cmd in ('remove',):
-           return True
+            return True
         return False
 
+    def cacheRequirement(self, base, basecmd, extcmds):
+        """Return the cache requirements for the remote repos.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: Type of requirement: read-only:past, read-only:present, read-only:future, write
+        """
+        cmd, extcmds = self._grp_cmd(basecmd, extcmds)
+
+        if cmd in ('list', 'info', 'summary'):
+            return 'read-only:past'
+        if cmd.startswith('mark') or cmd.startswith('unmark'):
+            return 'read-only:past'
+        return 'write'
+
+
 class MakeCacheCommand(YumCommand):
+    """A class containing methods needed by the cli to execute the
+    makecache command.
+    """
 
     def getNames(self):
+        """Return a list containing the names of this command.  This
+        command can be called from the command line by using any of these names.
+
+        :return: a list containing the names of this command
+        """
         return ['makecache']
 
     def getUsage(self):
+        """Return a usage string for this command.
+
+        :return: a usage string for this command
+        """
         return ""
 
     def getSummary(self):
+        """Return a one line summary of this command.
+
+        :return: a one line summary of this command
+        """
         return _("Generate the metadata cache")
 
     def doCheck(self, base, basecmd, extcmds):
+        """Verify that conditions are met so that this command can
+        run; namely that there is an enabled repository.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        """
         checkEnabledRepo(base)
 
     def doCommand(self, base, basecmd, extcmds):
+        """Execute this command.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
         base.logger.debug(_("Making cache files for all metadata files."))
         base.logger.debug(_("This may take a while depending on the speed of this computer"))
-        try:
-            for repo in base.repos.findRepos('*'):
+
+        # Fast == don't download any extra MD
+        fast = False
+        if extcmds and extcmds[0] == 'fast':
+            fast = True
+
+        if True: # Try, YumBase...
+            for repo in base.repos.sort():
                 repo.metadata_expire = 0
-                repo.mdpolicy = "group:all"
+                if not fast:
+                    repo.mdpolicy = "group:all"
             base.doRepoSetup(dosack=0)
             base.repos.doSetup()
-            for repo in base.repos.listEnabled():
-                repo.repoXML
             
             # These convert the downloaded data into usable data,
             # we can't remove them until *LoadRepo() can do:
             # 1. Download a .sqlite.bz2 and convert to .sqlite
             # 2. Download a .xml.gz and convert to .xml.gz.sqlite
-            base.repos.populateSack(mdtype='metadata', cacheonly=1)
-            base.repos.populateSack(mdtype='filelists', cacheonly=1)
-            base.repos.populateSack(mdtype='otherdata', cacheonly=1)
-
+            if fast:
+                #  Can't easily tell which other metadata each repo. has, so
+                # just do primary.
+                base.repos.populateSack(mdtype='metadata', cacheonly=1)
+            else:
+                base.repos.populateSack(mdtype='all', cacheonly=1)
+
+            # Now decompress stuff, so that -C works, sigh.
+            fname_map = {'group_gz'   : 'groups.xml',
+                         'pkgtags'    : 'pkgtags.sqlite',
+                         'updateinfo' : 'updateinfo.xml',
+                         'prestodelta': 'prestodelta.xml',
+                         }
+            for repo in base.repos.listEnabled():
+                for MD in repo.repoXML.fileTypes():
+                    if MD not in fname_map:
+                        continue
+                    if MD not in repo.retrieved or not repo.retrieved[MD]:
+                        continue # For fast mode.
+                    misc.repo_gen_decompress(repo.retrieveMD(MD),
+                                             fname_map[MD],
+                                             cached=repo.cache)
 
-        except yum.Errors.YumBaseError, e:
-            return 1, [str(e)]
         return 0, [_('Metadata Cache Created')]
 
     def needTs(self, base, basecmd, extcmds):
+        """Return whether a transaction set must be set up before this
+        command can run.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: True if a transaction set is needed, False otherwise
+        """
         return False
 
 class CleanCommand(YumCommand):
+    """A class containing methods needed by the cli to execute the
+    clean command.
+    """
     
     def getNames(self):
+        """Return a list containing the names of this command.  This
+        command can be called from the command line by using any of these names.
+
+        :return: a list containing the names of this command
+        """
         return ['clean']
 
     def getUsage(self):
+        """Return a usage string for this command.
+
+        :return: a usage string for this command
+        """
         return "[headers|packages|metadata|dbcache|plugins|expire-cache|all]"
 
     def getSummary(self):
+        """Return a one line summary of this command.
+
+        :return: a one line summary of this command
+        """
         return _("Remove cached data")
 
     def doCheck(self, base, basecmd, extcmds):
+        """Verify that conditions are met so that this command can run.
+        These include that there is at least one enabled repository,
+        and that this command is called with appropriate arguments.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        """
         checkCleanArg(base, basecmd, extcmds)
         checkEnabledRepo(base)
         
     def doCommand(self, base, basecmd, extcmds):
+        """Execute this command.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
         base.conf.cache = 1
         return base.cleanCli(extcmds)
 
     def needTs(self, base, basecmd, extcmds):
+        """Return whether a transaction set must be set up before this
+        command can run.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: True if a transaction set is needed, False otherwise
+        """
         return False
 
+    def cacheRequirement(self, base, basecmd, extcmds):
+        """Return the cache requirements for the remote repos.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: Type of requirement: read-only:past, read-only:present, read-only:future, write
+        """
+        return 'read-only:past'
+
+
 class ProvidesCommand(YumCommand):
+    """A class containing methods needed by the cli to execute the
+    provides command.
+    """
+
     def getNames(self):
+        """Return a list containing the names of this command.  This
+        command can be called from the command line by using any of these names.
+
+        :return: a list containing the names of this command
+        """
         return ['provides', 'whatprovides']
 
     def getUsage(self):
+        """Return a usage string for this command.
+
+        :return: a usage string for this command
+        """
         return "SOME_STRING"
     
     def getSummary(self):
+        """Return a one line summary of this command.
+
+        :return: a one line summary of this command
+        """
         return _("Find what package provides the given value")
 
     def doCheck(self, base, basecmd, extcmds):
+        """Verify that conditions are met so that this command can
+        run; namely that this command is called with appropriate arguments.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        """
         checkItemArg(base, basecmd, extcmds)
 
     def doCommand(self, base, basecmd, extcmds):
+        """Execute this command.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
         base.logger.debug("Searching Packages: ")
-        try:
-            return base.provides(extcmds)
-        except yum.Errors.YumBaseError, e:
-            return 1, [str(e)]
+        updateinfo.exclude_updates(base)
+        return base.provides(extcmds)
+
+    def cacheRequirement(self, base, basecmd, extcmds):
+        """Return the cache requirements for the remote repos.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: Type of requirement: read-only:past, read-only:present, read-only:future, write
+        """
+        return 'read-only:past'
+
 
 class CheckUpdateCommand(YumCommand):
+    """A class containing methods needed by the cli to execute the
+    check-update command.
+    """
+
     def getNames(self):
-        return ['check-update']
+        """Return a list containing the names of this command.  This
+        command can be called from the command line by using any of these names.
+
+        :return: a list containing the names of this command
+        """
+        return ['check-update',  'check-updates',
+                'check-upgrade', 'check-upgrades']
 
     def getUsage(self):
+        """Return a usage string for this command.
+
+        :return: a usage string for this command
+        """
         return "[PACKAGE...]"
 
     def getSummary(self):
+        """Return a one line summary of this command.
+
+        :return: a one line summary of this command
+        """
         return _("Check for available package updates")
 
     def doCheck(self, base, basecmd, extcmds):
+        """Verify that conditions are met so that this command can
+        run; namely that there is at least one enabled repository.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        """
         checkEnabledRepo(base)
 
-    def doCommand(self, base, basecmd, extcmds):
+    def doCommand(self, base, basecmd, extcmds, repoid=None):
+        """Execute this command.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
+        updateinfo.exclude_updates(base)
         obscmds = ['obsoletes'] + extcmds
-        base.extcmds.insert(0, 'updates')
+        extcmds.insert(0, 'updates')
         result = 0
-        try:
-            ypl = base.returnPkgLists(extcmds)
+        if True:
+            ypl = base.returnPkgLists(extcmds, repoid=repoid)
             if (base.conf.obsoletes or
                 base.verbose_logger.isEnabledFor(logginglevels.DEBUG_3)):
-                typl = base.returnPkgLists(obscmds)
+                typl = base.returnPkgLists(obscmds, repoid=repoid)
                 ypl.obsoletes = typl.obsoletes
                 ypl.obsoletesTuples = typl.obsoletesTuples
 
